FCHOWNAT(2)

NAME
fchownat - change ownership of a file relative to a directory file descriptor

SYNOPSIS
#include <unistd.h>

int fchownat(int dirfd, const char *pathname,
             uid_t owner, gid_t group, int flags);

DESCRIPTION
The fchownat() system call operates in exactly the same way as chown(2), except for the differences described in this manual page.

If the pathname given in pathname is relative, then it is interpreted relative to the directory referred to by the file descriptor dirfd (rather than relative to the current working directory of the calling process, as is done by chown(2) for a relative pathname).

If pathname is relative and dirfd is the special value AT_FDCWD, then pathname is interpreted relative to the current working directory of the calling process (like chown(2)).

If pathname is absolute, then dirfd is ignored.

flags can either be 0, or include the following flag:

AT_SYMLINK_NOFOLLOW
    If pathname is a symbolic link, do not dereference it: instead operate on the link itself, like lchown(2). (By default, fchownat() dereferences symbolic links, like chown(2).)

RETURN VALUE
On success, fchownat() returns 0. On error, -1 is returned and errno is set to indicate the error.

ERRORS
The same errors that occur for chown(2) can also occur for fchownat(). The following additional errors can occur for fchownat():

EBADF
    dirfd is not a valid file descriptor.

EINVAL
    Invalid flag specified in flags.

ENOTDIR
    pathname is relative and dirfd is a file descriptor referring to a file other than a directory.

NOTES
See openat(2) for an explanation of the need for fchownat().

CONFORMING TO
This system call is non-standard but is proposed for inclusion in a future revision of POSIX.1. A similar system call exists on Solaris.

VERSIONS
fchownat() was added to Linux in kernel 2.6.16.

SEE ALSO
chown(2), openat(2), path_resolution(2)